Subject: [Supa] Q4: Why does SUPA want to work on an information model at the time the IETF moves away from information models to focus on data models?

From: Benoit Claise <[email-masked]>
Date: Wed, 10 Jun 2015 23:20:49 +0200

Dear all,

 From the WIKI <https://github.com/IETF-SUPA/SUPA/wiki/Q-&-A>, there is 
a good discussion on Q4: Why does SUPA want to work on an information 
model at the time the IETF moves away from information models to focus 
on data models?
We could continue the discussion on the mailing list. Not sure who 
introduced the UNCLEAR statements but they make sense to me. My addition 
below with BENOIT. Hopefully, this is readable.

  *

    YANG models are proliferating. However, each YANG model is being
    worked on in relative isolation. This risks:

      o defining the same concepts in different ways
      o not reusing previous work
          + UNCLEAR why an information model helps here. The long-term
            goal of the SUPA proposition is a set of data models that
            provide re-usable components for, or sit on top of,
            application-specific data models that require to use policy.
            In that case there would be no further need to define the
            same concepts in any other data models, and it would be
            clear what previous work (that from SUPA) should be used.
            How does an information model help with this?
              # answer: an information model is independent of data
                repository, data definition language, query language,
                implementation language, and protocol. Hence, it is the
                mechanism for defining reusable concepts that all
                application-specific data models can use.

            BENOIT: and which other data model types than YANG do you
            have in mind?

  *

    An information model can be used to define common vocabulary and
    concepts that will help any implementation (including YANG data
    models) to better interoperate.

      o UNCLEAR. The suggestion appears to be two-fold. That an
        information model will help with the development of
        policy-related data models in languages other than YANG: are we
        really planning that in scope? And that YANG data models will
        interoperate better if there is an over-arching information
        model: but this implies that a) the data model will not include
        adequate explanation, b) the plan is for multiple,
        application-specific policy data models, whereas the other text
        implies a common policy data model that is re-used.
          + answer: An information model defines additional semantics
            that YANG does not define (in its current version). Such
            semantics depends on how the code is implemented, and the
            information model can give additional guidance for that
            implementation.

        BENOIT: so it's not good if we lose the semantic by specifying
        YANG models, right?

  *

    The information model defines object classes and metadata, enabling
    the characteristics and behavior of such classes to be described and
    prescribed. This is difficult to do in an interoperable way with
    data models, since data models are, by definition, technology-specific.

      o UNCLEAR. I don't see why data models are technology-specific by
        definition. Is it not possible to produce a data model for the
        concept of policy? Read in conjunction with the answer to Q2 it
        appears that you /only/ want to work on information models,
        although Q6 is quite clear about producing generic YANG models.
          + answer: RFC3198: "A mapping of the contents of an
            information model into a form that is specific to a
            particular type of data store or repository." SUPA is
            producing YANG policy models. YANG is, by definition, a
            technology-specific data model. The information model helps
            different YANG data models for different applications
            interoperate. Without SUPA, YANG data models built for one
            set of applications do not define common policies or
            metadata that enable them to interact with other YANG data
            models for other sets of applications.

Regards, Benoit

---

From: Benoit Claise <[email-masked]>
Date: Mon, 22 Jun 2015 16:02:04 +0200

I don't think I've seen any reply on this one.

Regards, Benoit
> introduced the UNCLEAR statements but they make sense to me. My 
> addition below with BENOIT. Hopefully, this is readable.
>
>
>  *
>
>             application-specific data models that require to use
>             policy. In that case there would be no further need to
>             define the same concepts in any other data models, and it
>             would be clear what previous work (that from SUPA) should
>             be used. How does an information model help with this?
>                 implementation language, and protocol. Hence, it is
>                 the mechanism for defining reusable concepts that all
>         policy-related data models in languages other than YANG: are
>         we really planning that in scope? And that YANG data models
>         will interoperate better if there is an over-arching
>         information model: but this implies that a) the data model
>         will not include adequate explanation, b) the plan is for
>         multiple, application-specific policy data models, whereas the
>         other text implies a common policy data model that is re-used.
>     The information model defines object classes and metadata,
>     enabling the characteristics and behavior of such classes to be
>     described and prescribed. This is difficult to do in an
>     interoperable way with data models, since data models are, by
>     definition, technology-specific.
>
>       o UNCLEAR. I don't see why data models are technology-specific
>         by definition. Is it not possible to produce a data model for
>         the concept of policy? Read in conjunction with the answer to
>         Q2 it appears that you /only/ want to work on information
>         models, although Q6 is quite clear about producing generic
>         YANG models.
>             technology-specific data model. The information model
>             helps different YANG data models for different
>             applications interoperate. Without SUPA, YANG data models
>             built for one set of applications do not define common
>             policies or metadata that enable them to interact with
>             other YANG data models for other sets of applications.
>
> Regards, Benoit
>
>
>
> _______________________________________________
> Supa mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/supa

---

From: John Strassner <[email-masked]>
Date: Mon, 22 Jun 2015 08:26:31 -0700

Pulling up your embedded questions:

> BENOIT: and which other data model types than YANG do you have in mind?

Sorry for any wording confusion; when I wrote the answers to the questions,
I didn't have any other data models in mind. Rather, I wanted to
concentrate on using an information model to capture semantics (e.g.,
relationships between objects).

> BENOIT: so it's not good if we lose the semantic by specifying YANG
models, right?

Yes. I think that SUPA COULD come up with new requirements for YANG.

regards,
John

On Mon, Jun 22, 2015 at 7:02 AM, Benoit Claise <[email-masked]> wrote:

> From the WIKI <https://github.com/IETF-SUPA/SUPA/wiki/Q-&-A>, there is a
> good discussion on Q4: Why does SUPA want to work on an information model
> at the time the IETF moves away from information models to focus on data
> models?
>    -
>     - defining the same concepts in different ways
>       - not reusing previous work
>          - UNCLEAR why an information model helps here. The long-term
>          goal of the SUPA proposition is a set of data models that provide re-usable
>          components for, or sit on top of, application-specific data models that
>          require to use policy. In that case there would be no further need to
>          define the same concepts in any other data models, and it would be clear
>          what previous work (that from SUPA) should be used. How does an information
>          model help with this?
>             - answer: an information model is independent of data
>             repository, data definition language, query language, implementation
>             language, and protocol. Hence, it is the mechanism for defining reusable
>             concepts that all application-specific data models can use.
>
>          BENOIT: and which other data model types than YANG do you have
>          in mind?
>             -
>
>    concepts that will help any implementation (including YANG data models) to
>    better interoperate.
>     - UNCLEAR. The suggestion appears to be two-fold. That an information
>       model will help with the development of policy-related data models in
>       languages other than YANG: are we really planning that in scope? And that
>       YANG data models will interoperate better if there is an over-arching
>       information model: but this implies that a) the data model will not include
>       adequate explanation, b) the plan is for multiple, application-specific
>       policy data models, whereas the other text implies a common policy data
>       model that is re-used.
>          - answer: An information model defines additional semantics that
>          YANG does not define (in its current version). Such semantics depends on
>          how the code is implemented, and the information model can give additional
>          guidance for that implementation.
>
>       BENOIT: so it's not good if we lose the semantic by specifying YANG
>       models, right?
>         -
>
>    prescribed. This is difficult to do in an interoperable way with data
>    models, since data models are, by definition, technology-specific.
>     - UNCLEAR. I don't see why data models are technology-specific by
>       definition. Is it not possible to produce a data model for the concept of
>       policy? Read in conjunction with the answer to Q2 it appears that you
>       *only* want to work on information models, although Q6 is quite
>       clear about producing generic YANG models.
>          - answer: RFC3198: "A mapping of the contents of an information
>          model into a form that is specific to a particular type of data store or
>          repository." SUPA is producing YANG policy models. YANG is, by definition,
>          a technology-specific data model. The information model helps different
>          YANG data models for different applications interoperate. Without SUPA,
>          YANG data models built for one set of applications do not define common
>          policies or metadata that enable them to interact with other YANG data
> Supa mailing [email-masked]://www.ietf.org/mailman/listinfo/supa
>
>
>

-- 
regards,
John